program Set09;
{
     
     

  (*** ,  43 ***)
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

////////////////////////////////////////////////////////////////
procedure Stirling(arg: TSet);
var k1, k2, n, m: integer;
       S: TSet;
begin
   m:= 0; k2:=1; n:=0;
   S:= arg.GetFirst as TSet;
   while Assigned(S) do begin
     k1:= S.GetCount;
     if k1=k2
       then Inc(n)
       else begin
         Writeln(n);
         m:= m+n;
         n:=1;
         k2:= k1;
       end;
     S:= TSet(arg.GetNext);
   end;
   Writeln(n);
   m:= m+n;
   Writeln('m= ',m);
end;
////////////////////////////////////////////////////////////////
(*** ,  43 ***)

var
    Power   : integer;  //   
    Univers : TSet;     //   
    Res: TSet;          //    
    Res2: TSet;         //    

{$define OUT}

begin
  try
    Randomize;
  repeat
    Write('Power= '); Readln(Power);
    if Power<2 then Break;

    {$ifdef OUT}
    Assign(Output,'Out.txt'); Rewrite(Output);
    {$endif}

    //   
    Univers:= GenerateChars(Power);
    Univers.Expo;
    Writeln('- - - - - - - - - - - - -');
    {
    //  
    Buf:= GenSubsRand(Univers, 20, 20, 40);
    Buf.Expo;
    Writeln('- - - - - - - - - - - - -');
    }
    //    
    {
    Res:= GenDissectRand(Univers, 10, 20, 40);
    Res.Expo;
    Res.Free;
    Writeln('- - - - - - - - - - - - -');
    }

    //    

    Res:= GenAllDissections(Univers);
    Res.Expo;
    Writeln('- - - - - - - - - - - - -');


    //    
(*
    Res2:= GenDissectAll(Res);
    Res2.Expo;
    Res2.Free;
*)
(*
    Res2:= GenSubsets(Res);
    Res2.Expo;
    Res2.Free;
*)

    // Stirling(Res);

    Res.Free;

    Univers.ClrAndDestroy;
    Univers.Free;
    Writeln('- - - - - - - - - - - - -');
    (*
    //   
    Univers:= GenerateNumbers(Power);
    Res:= GenByMerging(Univers);
    Res.Expo;
    Res.Free;
    Univers.Free;
    Writeln('- - - - - - - - - - - - -');
    *)
    {$ifdef OUT}
      Close(Output);
      Assign(Output,'');
      Rewrite(Output);
    {$endif}
  until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.

