program Set_10;

{       
 . 53
http://rain.ifmo.ru/cat/view.php/theory/graph-coloring-layout/covering-2004
}
{$APPTYPE CONSOLE}

{define OUT}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

////////////////////////////////////////////////////////////////
var
    Power   : integer;  //   
    BaseSet : TSet;     //   
    Res: TCostSet;          //
    BufSubs: TBuffer;  //   
    CostBuf: TBuffer;
    n: integer;
    S: string;
////////////////////////////////////////////////////////////////

begin
  try

    repeat

      Power:= 26;
      BaseSet:= GenerateChars(Power);
      BufSubs:= GenSubsRand(BaseSet, 200, 0, 40);
      CostBuf:= GenCostItems(1, BufSubs);
      {
      BaseSet:= CreateSet;
      CostBuf:= ReadSetsFromText('Test_in.txt', BaseSet);
      BaseSet.Expo;
      CostBuf.Expo;
      }

      //Res:= CollectMinDissect(BaseSet, CostBuf);
      Res:= CollectMinCover(BaseSet, CostBuf);
      Res.Expo;
      Res.Free;

      CostBuf.ClrAndDestroy;
      CostBuf.Free;
      BufSubs.Free;
      BaseSet.ClrAndDestroy;
      BaseSet.Free;
      Write('S= '); Readln(S);
    until S<>'';


    {$ifdef OUT}
    Assign(Output,'Out.txt'); Rewrite(Output);
    {$endif}
    //   
    BaseSet:= GenerateChars(Power);
    BaseSet.Expo;
    Writeln('- - - - - - - - - - - - -');

    //   
    BufSubs:= GenSubsRand(BaseSet, 50, 0, 75);

    //    
    {
     0: cost:= 1 + Random(99);
     1: cost:= 1;
     2: cost:= 1 + (n div 2) + Random(n);
     3: cost:= n;
     4: cost:= 1 + (n-1)*(n-1);
    }
    CostBuf:= GenCostItems(1, BufSubs);
    BufSubs.Free;

    //CostBuf:= ReadSetsFromText('Input.txt');
    //CostBuf.Expo;

    repeat
      Writeln('- - - - - - - - - - - - -');
      Res:= CollectMinDissect(BaseSet, CostBuf);
      Res.Expo;
      n:= Res.mSet.GetCount;
      Writeln('Cost= ',CalcCost(Res.mSet));
      RemoveItemsFromBuf(CostBuf, Res.mSet);
      Res.Free;
    until (n=0);

    //CostBuf.Expo;
    repeat
      Writeln('- - - - - - - - - - - - - - - - - - - - - - - - -');
      Res:= CollectMinCover(BaseSet, CostBuf);
      n:= Res.mSet.GetCount;
      Res.Expo;
      RemoveItemsFromBuf(CostBuf, Res.mSet);
      Res.Free;
    until n=0;
    Writeln('- - - - - - - - - - - - - - - - - - - - - - - - -');

    {$ifdef OUT}
      Close(Output);
    {$else}
      Write('OK');
      Readln;
    {$endif}

  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.

