program Set_10a;
////////////////////////////////////////////////////////////////
///    
//*** ,  43 ***

{$APPTYPE CONSOLE}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

//      

procedure FreeSubSets(arg: TSet);
var  S : TSet;  //   ( )
begin
  S:= arg.GetFirst as TSet;   //   
  while Assigned(S) do begin
    S.ClrAndDestroy;          //    
    S:= arg.GetNext as TSet;  //   
  end;
end;

var
    Power   : integer;  //   
    Univers : TSet;     //    -- 
    Res: TSet;          //   

begin  {----- Main -----}
  try
  repeat
    Write('Power= '); Readln(Power);  //   
    if Power<2 then Break;

    //     
    Univers:= GenerateChars(Power);
    Univers.Expo;
    Writeln('- - - - - - - - - - - - -');

    Res:= GenAllDissections(Univers);  //   
    Res.Expo;
    Writeln('- - - - - - - - - - - - -');

    FreeSubSets(Res);   //     
    Res.ClrAndDestroy;  //   
    Res.Free;           //   

    Univers.ClrAndDestroy; //   ""
    Univers.Free;          //   ""
  until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
