program Graph_17a;
//////////////////////////////////////////////////////////////
//    (Undepend Set)

{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';
(******************************************************
KRISTOFIDES Page 44
0 - (0), (1)
0 -  
0 -   ()
8 -  
A B C D E F G H
A -> B F H
B -> A C F
C -> B D E
D -> C E G
E -> C D F
F -> A B E G H
G -> D F
H -> A F
******************************************************)

var Gr: TGraphChars;
    Undep: TSet;
    S : string;
    Start, Time : TDateTime;
    N: integer;

begin
  try
  //Assign(Output,'Out.txt'); Rewrite(Output);
  repeat
    Gr:= TGraphChars.Load('Page44.txt');
    //Gr:= TGraphChars.Load('Test_4.txt');
    //Gr:= TGraphChars.Load('Test2.txt');
    //Gr:= TGraphChars.GenRandom(false, 1, 1, 25, 100);
    Gr.Expo;
    Writeln('- - - - - - - - - - - - - - - - - -');

    Start:= Now;
    for N:= 1 to 1 do begin
      Undep:= Gr.GenUndepend;
      if N=1 then Undep.Expo;
      //  
      Undep.ClrAndDestroy;
      Undep.Free;
    end;

    Time:= MilliSecondsBetween(Start, Now);
    Writeln('- - UNDEPEND SET - -');
    Writeln('Time (ms) = ', Time:5:1);
    Readln(S);
    if S='s' then Gr.Save('Saved.txt');

    Gr.Free; //  
  until S<>'';
  //Close(Output);
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
