program Graph_33d;
{
   
       
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

var Gr  : TGraph;
    Res : TBuffer;
    Cost: integer;
      i : integer;

    Start : TDateTime;
    Time  : integer;

    Nodes : integer;  //  
    Retry : integer;  //  
    Direct: boolean;  //  

    // :
    TT : integer; // 
    TF : integer; // 

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 //  
procedure ResultExpo(const aFile: String);
begin
  if aFile <> '' then begin
    Assign(Output, aFile);
    if FileExists(aFile)  then Append(Output)   else Rewrite(Output)
  end;
  Writeln('-----------------------------------------------------------');
  Writeln('Nodes=', Nodes:4, '  Retry=', Retry:4);
  Writeln('true = ', TT/Retry:7:1);
  Writeln('false= ', TF/Retry:7:1);
  Writeln('-----------------------------------------------------------');
  if aFile <> '' then begin
    Close(Output);  Assign(Output, '');    Rewrite(Output);
  end;
end;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


begin
  try
  repeat
    Write('Nodes= '); Readln(Nodes);
    if Nodes<5 then Break;
    repeat
      Write('Retry= '); Readln(Retry);
      if Retry=0 then Break;
      //  
      TF:=0; TT:=0;

      for Direct:= false to true do begin
        for i:= 1 to Retry do begin
          if Direct then Write('.') else Write('`') ;
          Gr:= TGraphChars.GenFull(Direct, 0, 99, Nodes);
          //-------------------------------------------
          //  
          Start:= Now;
          Res:= Gr.GenHamilton(Cost);
          Time:= MilliSecondsBetween(Start, Now);
          Res.Free;
          if Direct then Inc(TT, Time) else Inc(TF, Time); ;
          Gr.Free;
        end;
        Writeln;
      end;
      ResultExpo('');
      ResultExpo('Out_19e.txt');
    until false;
  until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
