program Set07;
{
      
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

////////////////////////////////////////////////////////////////

var BaseSet : TSet;

procedure Generate(arg: word);
var i: integer;
    c: char;
begin
  BaseSet:= CreateSet;
  c:='a';
  for i:= 1 to arg do begin
    BaseSet.Insert(TItemChar.Create(c));
    c:= Succ(c);
  end;
end;

////////////////////////////////////////////////////////////////

procedure Rand;
var i: integer;
    x : TSet;
    Sets: TSet;
    p: TItem;
begin
  Randomize;
  Sets:= CreateSet;
  for i:= 1 to 5 do begin
    x:= CreateSet;
    p:= BaseSet.GetFirst;
    while Assigned(p) do begin
      if Random(2)=0 then x.Insert(p);
      p:= BaseSet.GetNext;
    end;
    Sets.Insert(x);
  end;
  Sets.Expo;
  Sets.ClrAndDestroy;
  Sets.Free;
end;

////////////////////////////////////////////////////////////////
var s: string;

begin
  try
    Generate(5);
    repeat
      Rand;
      Writeln('----------');
      Readln(s);
    until s<>'';
    BaseSet.ClrAndDestroy;
    BaseSet.Free;

  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
